PHDRS {
  core		PT_LOAD;
  init		PT_LOAD;
  mod		0x60000001;
  dyn		PT_DYNAMIC;
}

SECTIONS
{
  .text : { *(.text) } :core
  .gnu.linkonce.this_module : { *(.gnu.linkonce.this_module) } :core :mod
  .rodata : { *(.rodata) *(.rodata.*) } :core

  /* Generated module information */
  __ex_table : { 
	__start___ex_table = .;
	*(__ex_table)
	__stop___ex_table = .;
  } :core

  __ksymtab : {
	__start___ksymtab = .;
	*(__ksymtab)
	__stop___ksymtab = .;
  } :core

  .data : { *(.data) CONSTRUCTORS } :core
  .plt : { *(.plt) } :core
  .got : { *(.got.plt) *(.got) } :core
  .sdata : { *(.sdata) *(.sdata2) } :core
  .sbss : { *(.sbss) *(.dynsbss) *(.scommon) } :core
  .bss : { *(.bss) *(.dynbss) *(COMMON) } :core

  .init.text ALIGN(8192) : {
	__module_cut = .; /* From here down can be discarded. */
	*(.init.text)
  } :init
  .init.data : {
	*(.init.data) *(.init.setup) *(.init.param) *(.param.init)
  } :init

  __param : {
	__start___param = .;
	*(__param)
	__stop___param = .;
  } :init

  __obsparm : {
	__start___obsparm = .;
	*(__obsparm)
	__stop___obsparm = .;
  } :init

  .hash : { *(.hash) } :init
  .dynsym : { *(.dynsym) } :init
  .dynstr : { *(.dynstr) } :init

  /* This should work, but doesn't. RELA==JMPREL, and DT_RELASZ is too small.*/
  /*.rela.plt : { *(.rela.plt) }*/
  /*.rela.dyn : { *(.rela*) }*/

  .rela.dyn :
    {
      *(.rela.init)
      *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
      *(.rela.fini)
      *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*)
      *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)
      *(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*)
      *(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*)
      *(.rela.ctors)
      *(.rela.dtors)
      *(.rela.got)
      *(.rela.toc)
      *(.rela.sdata .rela.sdata.* .rela.gnu.linkonce.s.*)
      *(.rela.sbss .rela.sbss.* .rela.gnu.linkonce.sb.*)
      *(.rela.sdata2 .rela.sdata2.* .rela.gnu.linkonce.s2.*)
      *(.rela.sbss2 .rela.sbss2.* .rela.gnu.linkonce.sb2.*)
      *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)
      *(.rela.tocbss)
	*(.rela.gnu.linkonce.this_module)
	*(.rela.opd)
	*(.rela.toc1)
	*(.rela__ksymtab)
	*(.rela__param)
	*(.rela.branch_lt)
    } :init

  .rela.plt : { *(.rela.plt) } :init

  .dynamic : { *(.dynamic) } :init :dyn

  .comment        0 : { *(.comment) }
  .mdebug         0 : { *(.mdebug) }
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }

   /* Unnamed sections end up in going in last mentioned phdr. */
  .dummy : { *(.dummy) } :core
}
