PHDRS {
  core		PT_LOAD;
  mod		0x60000001;
  init		PT_LOAD;
  dyn		PT_DYNAMIC;
}

SECTIONS
{
  .rodata : { *(.rodata) *(.rodata.*) } :core
  .data : { *(.data) CONSTRUCTORS } :core
  .got : { *(.got.plt) *(.got) } :core
  .sdata : { *(.sdata) *(.sdata2) } :core
  .sbss : { *(.sbss) *(.dynsbss) *(.scommon) } :core
  .text : { *(.text) } :core
  .plt : { *(.plt) } :core

  /* Generated module information */
  __ex_table : { 
	__start___ex_table = .;
	*(__ex_table)
	__stop___ex_table = .;
  } :core

  __ksymtab : {
	__start___ksymtab = .;
	*(__ksymtab)
	__stop___ksymtab = .;
  } :core

  .gnu.linkonce.this_module : { *(.gnu.linkonce.this_module) } :mod :core

  /* This needs to be at end of core, otherwise it causes mod segment
     p_vaddr to be calculated wrongly, and other things break too. */
  .bss : { *(.bss) *(.dynbss) *(COMMON) } :core

  .init.text ALIGN(4096) : {
	__module_cut = .; /* From here down can be discarded. */
	*(.init.text)
  } :init
  .init.data : { *(.init.data) *(.init.setup) *(.init.param) } :init

  __param : {
	__start___param = .;
	*(__param)
	__stop___param = .;
  } :init

  __obsparm : {
	__start___obsparm = .;
	*(__obsparm)
	__stop___obsparm = .;
  } :init

  .exports : { *(.exports) } :init

  .hash : { *(.hash) } :init
  .dynsym : { *(.dynsym) } :init
  .dynstr : { *(.dynstr) } :init
/* .rel.plt needs to be in its own section: don't use wildcard. */
/*  .rel.dyn : { *(.rel*) } :init */

  .rel.dyn : { *(.rel.dyn) } :init
  .rel.gnu.linkonce.this_module : { *(.rel.gnu.linkonce.this_module) } :init
  .rel.text : { *(.rel.text) } :init
  .rel.init.text : { *(.rel.init.text) } :init
  .rel__ksymtab : { *(.rel__ksymtab) } :init
  .rel__param : { *(.rel__param) } :init
  .rel.plt : { *(.rel.plt) } :init

  .dynamic : { *(.dynamic) }  :init :dyn

  /* Buggy lds drop random sections in the last mentioned segment. */
  .dummy : { *(.dummy) } :core
}
