PHDRS {
  core		PT_LOAD;
  mod		0x60000001;
  init		PT_LOAD;
  dyn		PT_DYNAMIC;
}

SECTIONS
{
  .text : { *(.text) } :core
  .plt : { *(.plt) } :core
  .rodata : { *(.rodata) *(.rodata.*) } :core
  .data : { *(.data) CONSTRUCTORS } :core
  .opd : { *(.opd) } :core
  .IA_64.unwind_info : { *(.IA_64.unwind_info* .gnu.linkonce.ia64unwi.*) } :core
  .IA_64.unwind : { *(.IA_64.unwind* .gnu.linkonce.ia64unw.*) } :core
  .got : { *(.got.plt) *(.got) } :core
  .IA_64.pltoff   : { *(.IA_64.pltoff) }
  .sdata : { *(.sdata) *(.sdata2) } :core
  .sbss : { *(.sbss) *(.dynsbss) *(.scommon) } :core

  /* Generated module information */
  __ex_table : { 
	__start___ex_table = .;
	*(__ex_table)
	__stop___ex_table = .;
  } :core

  __ksymtab : {
	__start___ksymtab = .;
	*(__ksymtab)
	__stop___ksymtab = .;
  } :core

  .gnu.linkonce.this_module : { *(.gnu.linkonce.this_module) } :mod :core

  /* This needs to be at end of core, otherwise it causes mod segment
     p_vaddr to be calculated wrongly, and other things break too. */
  .bss : { *(.bss) *(.dynbss) *(COMMON) } :core

  .init.text ALIGN(4096) : {
	__module_cut = .; /* From here down can be discarded. */
	*(.init.text)
  } :init
  .init.data : { *(.init.data) *(.init.setup) *(.init.param) } :init

  __param : {
	__start___param = .;
	*(__param)
	__stop___param = .;
  } :init

  __obsparm : {
	__start___obsparm = .;
	*(__obsparm)
	__stop___obsparm = .;
  } :init

  .exports : { *(.exports) } :init

  .hash : { *(.hash) } :init
  .dynsym : { *(.dynsym) } :init
  .dynstr : { *(.dynstr) } :init
  .gnu.version    : { *(.gnu.version) } :init
  .gnu.version_d  : { *(.gnu.version_d) } :init
  .gnu.version_r  : { *(.gnu.version_r) } :init

  /* .rela.IA_64.pltoff needs its own section, which means no wildcards. */
  .rela.dyn :
    {
      *(.rela.init)
      *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
      *(.rela.fini)
      *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*)
      *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)
      *(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*)
      *(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*)
      *(.rela.ctors)
      *(.rela.dtors)
      *(.rela.got)
      *(.rela.toc)
      *(.rela.sdata .rela.sdata.* .rela.gnu.linkonce.s.*)
      *(.rela.sbss .rela.sbss.* .rela.gnu.linkonce.sb.*)
      *(.rela.sdata2 .rela.sdata2.* .rela.gnu.linkonce.s2.*)
      *(.rela.sbss2 .rela.sbss2.* .rela.gnu.linkonce.sb2.*)
      *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)
      *(.rela.tocbss)
	*(.rela.gnu.linkonce.this_module)
	*(.rela.opd)
	*(.rela.toc1)
	*(.rela__ksymtab)
	*(.rela__param)
	*(.rela.branch_lt)
    } :init

  .rela.IA_64.pltoff : { *(.rela.IA_64.pltoff) } :init

  .dynamic : { *(.dynamic) }  :init :dyn

  /* Buggy lds drop random sections in the last mentioned segment. */
  .dummy : { *(.dummy) } :core
}
