PHDRS {
  core		PT_LOAD;
  mod		0x60000001;
  init		PT_LOAD;
  dyn		PT_DYNAMIC;
}

SECTIONS
{
  .rodata : { *(.rodata) *(.rodata.*) } :core
  .data : { *(.data) CONSTRUCTORS } :core
  .got : { *(.got.plt) *(.got) } :core
  .sdata : { *(.sdata) *(.sdata2) } :core
  .sbss : { *(.sbss) *(.dynsbss) *(.scommon) } :core
  .text : { *(.text) } :core
  .plt : { *(.plt) } :core
  .eh_frame : { *(.eh_frame) } :core

  /* Generated module information */
  __ex_table : { 
	__start___ex_table = .;
	*(__ex_table)
	__stop___ex_table = .;
  } :core

  __ksymtab : {
	__start___ksymtab = .;
	*(__ksymtab)
	__stop___ksymtab = .;
  } :core

  .gnu.linkonce.this_module : { *(.gnu.linkonce.this_module) } :mod :core

  /* This needs to be at end of core, otherwise it causes mod segment
     p_vaddr to be calculated wrongly, and other things break too. */
  .bss : { *(.bss) *(.dynbss) *(COMMON) } :core

  .init.text ALIGN(4096) : {
	__module_cut = .; /* From here down can be discarded. */
	*(.init.text)
  } :init
  .init.data : { *(.init.data) *(.init.setup) *(.init.param) } :init

  __param : {
	__start___param = .;
	*(__param)
	__stop___param = .;
  } :init

  __obsparm : {
	__start___obsparm = .;
	*(__obsparm)
	__stop___obsparm = .;
  } :init

  .exports : { *(.exports) } :init

  .hash : { *(.hash) } :init
  .dynsym : { *(.dynsym) } :init
  .dynstr : { *(.dynstr) } :init

  .rela.dyn : { *(.rela.dyn) } :init
  .rela.got : { *(.rela.got) } :init
  .rela.gnu.linkonce.this_module : { *(.rela.gnu.linkonce.this_module) } :init
  .rela.text : { *(.rela.text) } :init
  .rela.init.text : { *(.rela.init.text) } :init
  .rela__ksymtab : { *(.rela__ksymtab) } :init
  .rela__param : { *(.rela__param) } :init
  .rela.plt : { *(.rela.plt) } :init

  .dynamic : { *(.dynamic) }  :init :dyn
}
