#! /bin/sh -e

if [ $# != 1 ] || [ ! -d "$1" ]; then
    echo Usage: import.sh KERNELDIR >&2
    echo This script copies the source files from a kernel dir into this directory. >&2
    exit 1
fi

# Headers (not list.h, it's been de-kernelified)
for f in module.h elf.h err.h init.h kmod.h moduleloader.h moduleparam.h
do
    # Make sure we break hardlinks.
    rm -f $f
    cp $1/include/linux/$f .
done

# Generic sources
for f in module.c extable.c
do
    # Make sure we break hardlinks.
    rm -f $f
    cp $1/kernel/$f .
done

# Architectures
for archdir in arch-*
do
    arch=`echo $archdir | sed 's/arch-//'`
    rm -f $archdir/module.c
    cp $1/arch/$arch/kernel/module.c $archdir || true
    rm -f $archdir/module.h
    cp $1/include/asm-$arch/module.h $archdir || true
done
