#include <linux/config.h>
#include <linux/module.h>

/* These are inserted by the arch-specific linker script */
extern struct exception_table_entry __start___ex_table[], __stop___ex_table[];
extern struct kernel_symbol __start___ksymtab[], __stop___ksymtab[];
extern struct kernel_param __start___param[], __stop___param[];
extern struct obsolete_modparm __start___obsparm[], __stop___obsparm[];
extern char __module_cut[];

/* These could be defined in the module, or will resolve to the kernel stubs */
extern int __initfn(void);
extern void __exitfn(void);

/* We use the linker to do a lot of this work for us. */
struct module __this_module __attribute__((section("this_module"))) = {
	.name = MODULE_NAME,
	.symbols = { .owner = &__this_module,
		     .start = __start___ksymtab,
		     .end = __stop___ksymtab,
	},
	.extable = { .start = __start___ex_table,
		     .end = __stop___ex_table,
	},
	.param_start = __start___param,
	.param_end = __stop___param,
	.init = __initfn,
	.cut_here = __module_cut,
#ifdef CONFIG_OBSOLETE_MODPARM
	.obsparam_start = __start___obsparm,
	.obsparam_end = __stop___obsparm,
#endif
#ifdef CONFIG_MODULE_UNLOAD
	.exit = __exitfn,
#endif
};
