/* ELF test module for loading */
#include <linux/config.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/moduleparam.h>

/* Various different variable types */
static int static_int_init = 1;
static int static_int_uninit;
static char static_string_uninit[20];
static char static_string_init[] = "1";
int int_init = 1;
int int_uninit;
char string_uninit[20];
char string_init[] = "1";
static int init_int __initdata = 1;
static int aligned_int ____cacheline_aligned __initdata = 6;

static int static_function(void)
{
	return 1;
}

int function(void)
{
	return 1;
}

extern void test_string(const char *str);

static int __init init(void)
{
#if 1
  	test_string("init\n");
#if 1
	printk("static_int_init = %i (1)\n", static_int_init);
	printk("static_int_uninit = %i (0)\n", static_int_uninit);
	printk("static_string_uninit = \"%s\" (\"\")\n", static_string_uninit);
	printk("static_string_init = \"%s\" (\"1\")\n", static_string_init);
	printk("int_init = %i (1)\n", int_init);
	printk("int_uninit = %i (0)\n", int_uninit);
	printk("string_uninit = \"%s\" (\"\")\n", string_uninit);
	printk("string_init = \"%s\" (\"1\")\n", string_init);
	printk("static function returns: %i (1)\n", static_function());
	printk("function returns: %i (1)\n", function());
	printk("init_int = %i (1)\n", init_int);
	printk("aligned_int = %i (6)\n", aligned_int);
	printk("&aligned_int %% %u = %lu (0)\n",
	       SMP_CACHE_BYTES,
	       ((unsigned long)&aligned_int & (SMP_CACHE_BYTES-1)));
#endif
#else
	unsigned long i;
	
	for (i = 0; i < 10000000; i++);
#endif
	return 0;
}

static void cleanup(void)
{
	printk("cleanup\n");
}

EXPORT_SYMBOL(function);
module_init(init);
module_exit(cleanup);
module_param(int_init, int, 000);
